"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("underscore"));
var ck_lib_1 = require("@ckstack/ck-lib");
exports.default = {
    isNumber: function (val) { return _.isNumber(val) && !Number.isNaN(Number(val)); },
    isOptionalNumber: function (val) { return _.isUndefined(val) || (_.isNumber(val) && !Number.isNaN(Number(val))); },
    isOptionalGteZeroNumber: function (val) { return _.isUndefined(val) || (_.isNumber(val) && !Number.isNaN(Number(val)) && Number(val) >= 0); },
    isOptionalGtZeroNumber: function (val) { return _.isUndefined(val) || (_.isNumber(val) && !Number.isNaN(Number(val)) && Number(val) > 0); },
    isGteZeroNumber: function (val) { return _.isNumber(val) && !Number.isNaN(Number(val)) && Number(val) >= 0; },
    isGtZeroNumber: function (val) { return _.isNumber(val) && !Number.isNaN(Number(val)) && Number(val) > 0; },
    isString: function (val) { return _.isString(val); },
    isOptionalString: function (val) { return _.isUndefined(val) || _.isString(val); },
    isOptionalNotTrimEmptyString: function (val) { return _.isUndefined(val) || (_.isString(val) && val.trim() !== ''); },
    isNotEmtpyString: function (val) { return _.isString(val) && val !== ''; },
    isNotTrimEmptyString: function (val) { return _.isString(val) && val.trim() !== ''; },
    isOptionalBooleanString: function (val) {
        if (_.isUndefined(val)) {
            return true;
        }
        if (!_.isString(val)) {
            return false;
        }
        var str = val.toLowerCase();
        return (str === 'true' || str === 'false');
    },
    isBooleanString: function (val) {
        if (!_.isString(val)) {
            return false;
        }
        var str = val.toLowerCase();
        return (str === 'true' || str === 'false');
    },
    isOptionalNumberString: function (val) {
        if (_.isUndefined(val)) {
            return true;
        }
        return !(!_.isString(val) || val.trim() === '' || Number.isNaN(Number(val)));
    },
    isNumberString: function (val) {
        if (_.isUndefined(val)) {
            return true;
        }
        return !(!_.isString(val) || val.trim() === '' || Number.isNaN(Number(val)));
    },
    isOptionalGtNumberString: function (val) {
        if (_.isUndefined(val)) {
            return true;
        }
        return !(!_.isString(val) || val.trim() === '' || Number.isNaN(Number(val)) || Number(val) <= 0);
    },
    isOptionalGteNumberString: function (val) {
        if (_.isUndefined(val)) {
            return true;
        }
        return !(!_.isString(val) || val.trim() === '' || Number.isNaN(Number(val)) || Number(val) < 0);
    },
    isOptionalBoolean: function (val) { return _.isUndefined(val) || _.isBoolean(val); },
    isObject: function (val) { return _.isObject(val); },
    isOptionalObject: function (val) { return _.isUndefined(val) || _.isObject(val); },
    isOptionalNotEmptyObject: function (val) { return _.isUndefined(val) || (_.isObject(val) && _.size(val) > 0); },
    isNotEmptyObject: function (val) { return _.isObject(val) && _.size(val) > 0; },
    isArray: function (val) { return _.isArray(val); },
    isOptionalArray: function (val) { return _.isUndefined(val) || _.isArray(val); },
    isNotEmptyArray: function (val) { return _.isArray(val) && _.size(val) > 0; },
    isNotTrimEmptyStringNotEmptyArray: function (val) {
        if (!_.isArray(val) || _.size(val) <= 0) {
            return false;
        }
        for (var _i = 0, val_1 = val; _i < val_1.length; _i++) {
            var element = val_1[_i];
            if (!_.isString(element) || element.trim() === '') {
                return false;
            }
        }
        return true;
    },
    isOptionalStatus: function (val) {
        if (_.isUndefined(val)) {
            return true;
        }
        if (!_.isNumber(val) || val === ck_lib_1.CkValue.STATUS.PAUSE) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.STATUS, val);
    },
    isOptionalFullStatus: function (val) {
        if (_.isUndefined(val)) {
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.STATUS, val);
    },
    isOptionalRole: function (val) {
        if (_.isUndefined(val)) {
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.ROLE, val);
    },
    isOptionalTerminal: function (val) {
        if (_.isUndefined(val)) {
            return true;
        }
        if (!_.isNumber(val)) {
            return false;
        }
        return ck_lib_1.CkValue.isValidValue(ck_lib_1.CkValue.TERMINAL, val);
    },
};
